#!/usr/bin/perl -w

$LogFile = "/var/log/ifmail/faqserver.log";
$DbmPath = "/var/lib/ifmail/faqserver/faqbase/files";

#   ,       FAQServer'a,
#     bad     , 
#  $QUEUE/spool    .
#
$QUEUE="/var/spool/ifmail/faqserver";

#          (
# ).
#   - User_Name@address.fidonet.org,  -     ,
#  
#
$UsersDbmPath = "/var/lib/ifmail/faqserver/faqbase/users";

# ,    
# >/usr/lib/ifmail/faqserver/outmail --    "outmail"
# >>/usr/lib/ifmail/faqserver/outmail --     "outmail"
# |/usr/sbin/sendmail -t  --  sendmail   
#
#$MAILCOMMAND=">>/usr/lib/ifmail/faqserver/outmail";
$MAILCOMMAND="|/usr/sbin/sendmail -t";
#$MAILCOMMAND=">/dev/stdout";

#       .
#     (     
# )  FAQsLimit,    .
#   -  ,    
#    .
#
# !!! !  $FAQsLimit     , 
#                   "" ;)
#
$FAQsLimit = 200000;

#       .  
#     ,  SizeSplitMessage,    
#  .
# 1000    50   ;)
# 
$SizeSplitMessage = 1000;

#        FAQsLimit.
#        spool-,  
# .    .
$OverflowTime=12*60*60;

if( !open( LOG, ">>".$LogFile )) {
	print STDERR "Cannot open log file. $!\n";
	exit( 1 );
}

print LOG "\n".&strtime( "log" )." faqserver.pl[$$] ".Start.".\n";

if( !dbmopen( %Files, $DbmPath, 0664 )) {
	&logger( "Cannot open $DbmPath. $!" );
	close( LOG );
	exit( 1 );
}
	
process_spool();	#    spool
process_queue();	#    

dbmclose( %Files );
print LOG &strtime( "log" )." faqserver.pl[$$] ".End.".\n";
close( LOG );
exit( 0 );

sub strtime {
	my( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst );
	my( $tm, $month );
	$tm = time;
	( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst ) = localtime( $tm );
	@months = ( Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec );
	return sprintf( "%3s %2d %02d:%02d:%02d", $months[$mon], $mday, $hour, $min, $sec );
}

sub logger {
	print LOG $_[0]."\n";
#	print LOG &strtime( "log" )." faqserver.pl[$$] ".$_[0]."\n";
#	system "logger -t faqserver.pl[$$] $_[0]";
}

sub process_queue
{
    local(@file,$file,$rc);

    @file=<$QUEUE/*>;

    foreach $file (@file)
    {
        if ( -f $file ) 
        { 
            open(IN,$file) || (&logger("Cannot open queue file $file"), next);
            $rc=&process_message();
            close(IN);
	    if ($rc)
	    {
		unlink($file) || &logger("Cannot unlink queue file $file");
	    }
	    else
	    {
		&logger("Bad message header in message ".&basename($file)." - moving to $QUEUE/bad");
		mkdir("$QUEUE/bad",0777) || (&logger("Cannot make directory $QUEUE/bad"), next) unless ( -d "$QUEUE/bad" );
		rename($file,"$QUEUE/bad/".&basename($file)) || &logger("Cannot move $file to $QUEUE/bad");
	    }
        }
    }
}

sub process_message
{
    my ($bytes, $date, $size);
    &parse_header() || return 0;

    &logger("Processing message from $USERADDR");
    unless (&process_message_body())
    {
    &logger( "Warning: Nothing to do with empty message!");
    return 1;
    }
    if (&scanbadreq()) { return 1; }	#  -   

#       
#	print "\n :@request\n";
    &sort_request();
#	print "\n :@request\n";
#    $bytes=dd_request(0);
    if( ! dbmopen( %Users, $UsersDbmPath, 0664 )) {
      &logger( "Error: Cannot open dbm file: $UsersDbmPath. $!\n" );
      return;
    }
    $date=0; $size=0;
    if (defined($Users{$USERADDR})) {  #    ? ?
      ($date, $size) = split(/ /, $Users{$USERADDR}, 2);
    }
    if ($size > $FAQsLimit) {
      #    ( ) ,   
&logger ("  : $size ");
if ($date+$OverflowTime>time()) {
&logger ("  ");
} else { &logger (" "); }
      print LOG "Queries was added to spool: ";
      open(IN,">>$QUEUE/spool/$USERADDR") || &logger("Error level 3+");
      foreach (@request)	{	#  @request  spool-
	  print IN "$_\n";		#   .
	  print LOG "$_ ";		# @request   
	}
      print LOG "\n";
      close(IN);
      $Users{$USERADDR}="$date 1000000000";
    } else {	#      -  
	$bytes=dd_request($size);
	#  ,    
	undef @_request if defined(@_request);
	for ($m=0; $m<scalar(@to_send); $m++) {
	  $_request[$m]=$request[$to_send[$m]];
	}	#  @_request  ,   .
	#     @_request
	&send_topics (@_request); #    
	if (scalar(@to_send) == scalar(@request)) {
	  #    .
	  #       
	  $Users{$USERADDR}=time()." ".$bytes;
	} else	{	#      .  .
	$m=0;				  #    @request ,
	  foreach (@to_send) {		  #     
	    splice(@request, $_-$m++, 1); # @to_send.
	  }
	print LOG "Queries will be spooled: ";
        open(IN,">$QUEUE/spool/$USERADDR") || &logger("Error level 3+");
	  foreach (@request)	{	#  @request  spool-
	    print IN "$_\n";		#   .
	    print LOG "$_ ";		# @request    ,
	  }				#   - 
	print LOG "\n";			# .
        close(IN);			#
	&send_message_have_spool(@request); #     
	#       
	$Users{$USERADDR}=time()." ".$bytes;
	}
    }
    dbmclose( %Users );
    return 1;
}


sub parse_addr
{
    local($line)=@_;
    return $1 if ($line=~/^[^<]*<(\S+@\S+)>/o);
    return $1 if ($line=~/^(\S+@\S+)/o);
}

sub parse_header
{
    undef $REPLYTO;
    undef $USERADDR;
    undef $SUBJECT;
    while(<IN>)
    {
        last if (/^\s*$/o); ## empty string -- break
        next unless (($headline,$value)=/([^:]+):\s*(.*)\s*$/o);
        $SUBJECT=$value if ($headline=~/^Subject$/io);
        $USERADDR=&parse_addr($value) if ($headline=~/^From$/io);
	$REPLYTO=&parse_addr($value) if ($headline=~/^Reply-To$/io);
    }
    return 0 unless (defined($USERADDR) && defined($SUBJECT)); #   A||S
    ($USERNAME,$USERHOST)=split("@",$USERADDR);
    $SUBJECT="" if ($SUBJECT eq '<none>');
    return 1;
}


sub process_message_body
{
    my ($i, $ns);
    undef @request if defined(@request);
    
    @request = split( /[ \t]+/, $SUBJECT );	#     

    $nq=scalar(@request);
    $ns=$nq;

    while (<IN>)
    {
        last if (/^---/o);
	next if (/^\s*$/o);
	s/^\s*(.*)\s*$/$1/;			#    

	@_request = split( /[ \t]+/, $1 );	#    _
	
	for ($i=0; $i<scalar(@_request); $i++)
	{
	    $request[$nq++]=$_request[$i];
	}
    }

if ($ns>0)
{
    print LOG "S:";
    for ($i=0; $i<$ns; $i++)
    {
	print LOG $request[$i]." ";
    }
    print LOG "\n";
}
if ($nq>$ns)
{
    print LOG "\nB:";
    for ($i=$ns; $i<$nq; $i++)
    {
	print LOG $request[$i]." ";
    }
    print LOG "\n";
}
return $nq;
}


sub scanbadreq
{
    my ($i, $s);

    $s=0;
    for ($i=0; $i<$nq; $i++)
    {
	unless (defined($Files{uc($request[$i])}))
	{
	$badreq[$s]=$i;
	unless ($s++) { print LOG "BADREQ:"; }
	print LOG $request[$i]." ";
	}
    }
    unless ($s) { return 0; }	#  -   
    print LOG "\n";
    &mailbadreq;		#    () ()
    #     :
    $i=0;
    foreach (@badreq)	{	splice(@request, $_-$i++, 1);	}
    if (scalar(@request)) { return 0;	#   , 
      } else { return 1; }		#     
}

sub mailbadreq
{
    my ($i, $FULL_NAME);
    open(OUT,$MAILCOMMAND) || die &logger("Bad mailing command $MAILCOMMAND");
    print OUT "From: FAQServer\@f768.n463.z2.fidonet.org\n";
#    print OUT "To: ".(defined($REPLYTO)?$REPLYTO:$USERADDR)."\n";
    print OUT "To: ".$USERADDR."\n";
    print OUT "Subject: ";
    if (scalar(@badreq)==1) { print OUT "   \n";} else {
	print OUT "   \n";
	}
    print OUT "X-FTN-Tearline: FTN robot at OberStation built on Perl version $]\n";
    print OUT "X-FTN-Origin: OberStation FAQServer                           (2:463/768\@FidoNet)\n";
    print OUT "\n";
    $FULL_NAME = $USERNAME;
    $FULL_NAME =~ s/\_/\ /g;
    print OUT ",  ".$FULL_NAME."!\n\n";

    print OUT "        OberStation FAQServer.\n";
    print OUT "      ";
    if (scalar(@badreq)==1) {
	print OUT " \"".$request[($badreq[0])]."\".\n\n";
print OUT <<EOM;
,         
 .

EOM
	} else {
	print OUT " :\n";
	for ($i=0; $i<scalar(@badreq); $i++)
	    {
	    print OUT "> ".$request[($badreq[$i])]."\n";
	    }
print OUT <<EOM;

,         
 .
EOM
	
	}

print OUT <<EOM;

%HELP -     OberStation FAQServer.
%LIST -   
%LONGLIST -        
EOM

    if (scalar(@badreq)==1) { print OUT "\n\n";}
    print OUT "\n...".`/usr/bin/uptime`;
    close(OUT);
}

sub sort_request
{		#    @request    
my ($i, $a, $b, $temp, $t);
$a=0;
$b=0;
    for ($i=1; $i<scalar(@request); $i++)	{
        ($temp, $a, $temp) = split (/ /, $Files{uc($request[$i-1])}, 3);
        ($temp, $b, $temp) = split (/ /, $Files{uc($request[$i])}, 3);
        if ($a<$b)	{
    	    $temp=$request[$i];
	    $request[$i]=$request[$i-1];
	    $request[$i-1]=$temp;
	    $i=0;
	}
    }
}

sub process_spool
{
  my(@file,$file, %Users, $i, $n, $spoolfname, $size, $date, $t, $m);
  my($bytes, @_request, $temp);

    unless ( -d "$QUEUE/spool" ) {
	if	(!mkdir ("$QUEUE/spool", 0755))	{
	&logger ("Can't creat spool directory $QUEUE/spool. $!");
	close( LOG );
	exit( 1 );
	};
    }

#    .

  if( ! dbmopen( %Users, $UsersDbmPath, 0664 )) {
    &logger( "Error: Cannot open dbm file: $UsersDbmPath. $!\n" );
    return;
  }

#   : %Users{usernameadr}=(date, size)
#$Users{'Sergei_Oberemchuk@p8.f768.n463.z2.fidonet.org'}="96488046 452354");


  $n=scalar(keys %Users);
  &logger ("Processing spooled requests...");
  for ($i=0; $i<$n; $i++)	{	#     
    ($spoolfname, $temp) = each %Users;
    ($date, $size) = split (/ /, $temp, 2);
#print "\n$i - $spoolfname";
      if (($size<$FAQsLimit)&&($date+$OverflowTime<time())){ # Old user, no spool
					#   ,   
        foreach (keys %Users) { ; }	#    
                                        #      :( ??
        delete $Users{$spoolfname};
      } #  ,     + 
    elsif(($size>$FAQsLimit) && ($date+$OverflowTime<time())) {
      #   spool   ,   
      if ( -f "$QUEUE/spool/$spoolfname" ) { #   ,    
	undef @request if defined(@request);
        open(IN,"$QUEUE/spool/$spoolfname") || &logger("Error level 3");
	$m=0;
	while (<IN>)
	{
	  next if (/^$/o);	#   () - 
	  $request[$m++]=$_;
	}
        close(IN);
	chomp @request;		#  \n    
	&logger("Spool for $spoolfname: @request");
	$bytes=dd_request(0);
	#  ,    ,       
	undef @_request if defined(@_request);
	for ($m=0; $m<scalar(@to_send); $m++) {
	  $_request[$m]=$request[$to_send[$m]];
	}	#  @_request  ,   .
	#     @_request
	$USERADDR=$spoolfname;
	&send_topics (@_request); #    
	if (scalar(@to_send) == scalar(@request)) {
	  #      .  .
	  unlink("$QUEUE/spool/$spoolfname") || &logger("Cannot unlink spoolfile $file");
	  #       
	  $Users{$spoolfname}=time()." ".$bytes;
	} else	{	#        
	$m=0;				  #    @request ,
	  foreach (@to_send) {		  #     
	    splice(@request, $_-$m++, 1); # @to_send.
	  }
	print LOG "Queries from spool wasn't send: ";
        open(IN,">$QUEUE/spool/$spoolfname") || &logger("Error level 3+");
	  foreach (@request)	{	#  @request  spool-
	    print IN "$_\n";		#   .
	    print LOG "$_ ";		# @request    ,
	  }				#   - 
	print LOG "\n";			# .
        close(IN);			#
	&send_message_have_spool(@request); #     
	#       
	$Users{$spoolfname}=time()." ".$bytes;
	}
      } else {				     #   -  :(
          &logger("     $spoolfname!");
          &logger(" $spoolfname !");
	  foreach (keys %Users) { ; }	#    
	  delete $Users{$spoolfname};
      }
    }	elsif(($size<$FAQsLimit) && ($date+$OverflowTime>time())) {
				#   ,    spool-
	  if (-f "$QUEUE/spool/$spoolfname") { # - - ?
					       #     
					       # ,   .  .
	  $Users{$spoolfname}=$date." 1000000000";
	  }	#   ,    ,     
    }	elsif(($size>$FAQsLimit) && ($date+$OverflowTime>time())) {
      #   ,   .
	  unless (-f "$QUEUE/spool/$spoolfname") { # - - ?
					       #     
					       # ,   .  
	    $Users{$spoolfname}=$date." 0";
	    &logger("Spool file was deleted: $spoolfname");
	  }	#   ,   ,     
    }
  }


#      
@file=<$QUEUE/spool/*>;
foreach $file (@file)
  {
    #   $file  :
    $spoolfname=substr($file, rindex($file, "$QUEUE/spool/")+7+length($QUEUE));
    if ( -f $file ) 				#  spool-$file  
    { unless (defined ($Users{$spoolfname})) 	#     
      {                                         #   . 
						#  spool,    
	undef @request if defined(@request);
        open(IN,"$QUEUE/spool/$spoolfname") || &logger("Error level 6");
	$m=0;
	while (<IN>)
	  {
	    next if (/^$/o);	#   () - 
	    $request[$m++]=$_;
	  }
        close(IN);
	chomp @request;		#  \n    
	  for ($m=0; $m<scalar(@request); $m++)	#   
	    {					#    
	      unless (defined($Files{$request[$m]})) #   spool-,
	        {				#   
		  splice(@request, $m--, 1);
		}
	    }
	  if (scalar(@request)) {
	    &logger("Found new spool for $spoolfname, processing: @request");
	  } else {
	    &logger("Found new spool for $spoolfname: No correct querries!");
	  }
	$bytes=dd_request(0);
	#  ,    ,       
	undef @_request if defined(@_request);
	  for ($m=0; $m<scalar(@to_send); $m++) {
	    $_request[$m]=$request[$to_send[$m]];
	  }	#  @_request  ,   .
	#     @_request
	$USERADDR=$spoolfname;
	($USERNAME,$USERHOST)=split("@",$USERADDR);
	&send_topics (@_request); #    
	  if (scalar(@to_send) == scalar(@request)) {
	    #      .  .
	    unlink("$QUEUE/spool/$spoolfname") || &logger("Cannot unlink spoolfile $file");
	      if (scalar(@request) != 0) {	#    
	        $Users{$spoolfname}="0 ".$bytes;	#     
	      }						# -   
	  } else	{	#        
	    $m=0;			  #    @request ,
	    foreach (@to_send) {	  #     
	      splice(@request, $_-$m++, 1); # @to_send.
	    }
	    print LOG "Queries from new spool wasn't send: ";
            open(IN,">$QUEUE/spool/$spoolfname") || &logger("Error level 3+");
	      foreach (@request)  {	#  @request  spool-
	        print IN "$_\n";	#   .
	        print LOG "$_ ";	# @request    ,
	      }				#   - 
	    print LOG "\n";		# .
            close(IN);			#
&logger("   ");
	    &send_message_have_spool(@request); #     
	    #       
	    $Users{$spoolfname}=time()." ".$bytes;
	  }
      } #     .   
    }	# ,      .  .
  }	#     

  dbmclose( %Users );
  &logger ("Spool processind ends.");
  return;
}

sub dd_request
{
  my ($t, $n, $i, $m, $bytes);
  $bytes=$_[0];
    undef @to_send if defined(@to_send);
    #  ,        @request.
    #   ,     .
    for ($t=1; $t<scalar(@request); $t++)	{
	$n=$t;
	while ($n-->0)	{
	    if	(
		(uc($request[$n]) eq uc($request[$t]))
		||((uc($request[$t]) eq 'HELP')&&(uc($request[$n]) eq '%HELP'))
		||((uc($request[$t]) eq '%HELP')&&(uc($request[$n]) eq 'HELP'))
		||((uc($request[$t]) eq 'LIST')&&(uc($request[$n]) eq '%LIST'))
		||((uc($request[$t]) eq '%LIST')&&(uc($request[$n]) eq 'LIST'))
		||((uc($request[$t]) eq 'LONGLIST')&&(uc($request[$n]) eq '%LONGLIST'))
		||((uc($request[$t]) eq '%LONGLIST')&&(uc($request[$n]) eq 'LONGLIST'))
		) {
		splice(@request, $t--, 1);
	    }	
	}
    }


#   ,      .
#     @request    @to_send.
$n=0;
for ($i=0; ( $i < scalar(@request) ) && ( $bytes < $FAQsLimit ); $i++)	{
  if (defined ($Files{uc($request[$i])})) { #         ?
    if ($Files{uc($request[$i])} =~ /.+\s(\d+)\s.+/)	{
      if ($1+$bytes < $FAQsLimit)	{			#   
        $bytes+=$1;
	$to_send[$n++]=$i;
      }
    }	else	{	&logger ("Error level 1\n   $request[$i]");	}
  } else { &logger ("Can't found topic $request[$i]!"); }
}

if (scalar(@to_send)!=scalar(@request)) {	# $bytes -  
  $bytes=1000000000;				#  .
  } 

return $bytes;
}


sub send_message_have_spool
{
    my ($i, @requests, $temp, $description, $tmppipe, $FULL_NAME);
    @requests=@_;

format ONE_REQ =
>
> @<<<<<<<<<<<  ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
   $requests[0],   $description
>~~		 ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
		  $description
>

.

format REQ_S =
>
.

format REQ_F =
> @<<<<<<<<<<<  ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
   $requests[$i],  $description
>~~		 ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
		  $description
>
.

format REQ_END =
> :        @<<<<                                                      
		  $i
>

.

    open(OUT,$MAILCOMMAND) || die &logger("Bad mailing command $MAILCOMMAND");
    $tmppipe=select;	#    
    select OUT;		#      $MAILCOMMAND
    print "From: FAQServer\@f768.n463.z2.fidonet.org\n";
#    print "To: ".(defined($REPLYTO)?$REPLYTO:$USERADDR)."\n";
    print "To: ".$USERADDR."\n";
    print "Subject: ";
    if (scalar(@requests)==1) { print "  \n";} else {
	print "  \n";
	}
    print "X-FTN-Tearline: FTN robot at OberStation built on Perl version $]\n";
    print "X-FTN-Origin: OberStation FAQServer                           (2:463/768\@FidoNet)\n";
    print "\n";

    $FULL_NAME = $USERNAME;
    $FULL_NAME =~ s/\_/\ /g;
    print ",  ".$FULL_NAME."!\n\n";

    if (scalar(@requests)==1) {
      print "        OberStation FAQServer.\n";
      print "    :\n";
      if (defined($Files{$requests[0]}))	{  #     ?
	($temp, $temp, $temp, $description) = split (/[ \t]+/, $Files{uc($request[0])}, 4);
	  $~=ONE_REQ;
	  write;
      } else { # ,     .    
	&logger("Can't find request in db to print: $request[$i]");
      }
    } else {
      print "        OberStation FAQServer.\n";
      print "   :\n";
      $~ = REQ_S;
      write;
      for ($i=0; $i<scalar(@requests); $i++) { #   
	if (defined($Files{$requests[$i]}))	{  #     ?
	  ($temp, $temp, $description) = split (/ /, $Files{uc($request[$i])}, 3);
	  $~=REQ_F;
	  write;
	} else { # ,     .    
	  &logger("Can't find request in db to print: $request[$i]");
	}
      }		#   
      $~=REQ_END;
      write;
    }	#  ,    .

print <<EOM;
       .

!      __ __ !

   ,       .
EOM

print "\n...".`/usr/bin/uptime`;
close(OUT);
select $tmppipe;	#    

}


sub send_topics
{
my ($i, @requests, $temp, $filename, $pages, $subj);
  foreach (@requests=@_)
  {
    $subj = $_;
    ($filename, $temp, $temp, $temp) = split (/[ \t]+/, $Files{uc($subj)}, 4);
    open(REQFILE, $filename) || die &logger("Can't open topic file $filename");
    # ,       
    $i=0;
    ++$i while (<REQFILE>);
    seek REQFILE,0,0;			#     ;)
      if ($i<$SizeSplitMessage)		#      
      {
	  open(OUT,$MAILCOMMAND) || die &logger("Bad mailing command $MAILCOMMAND");
	  print OUT "From: FAQServer\@f768.n463.z2.fidonet.org\n";
#	  print OUT "To: ".(defined($REPLYTO)?$REPLYTO:$USERADDR)."\n";
	  print OUT "To: ".$USERADDR."\n";
	  print OUT "Subject: $subj\n";
	  print OUT "X-FTN-Tearline: FTN robot at OberStation built on Perl version $]\n";
	  print OUT "X-FTN-Origin: OberStation FAQServer                           (2:463/768\@FidoNet)\n";
	  print OUT "\n";
            while (<REQFILE>) {
	      print OUT "$_";
	    }
	  print OUT "\n...   .";
	  close(OUT);
      } else {				#      
	$pages=($i-$i%$SizeSplitMessage)/$SizeSplitMessage+1;
	--$pages unless($i % $SizeSplitMessage);
        $i=0;
          while (<REQFILE>) {	#  
	    $page=($i-$i%$SizeSplitMessage)/$SizeSplitMessage+1;
	    unless ($i % $SizeSplitMessage) { #   
	      open(OUT,$MAILCOMMAND) || die &logger("Bad mailing command $MAILCOMMAND");
	      print OUT "From: FAQServer\@f768.n463.z2.fidonet.org\n";
#	      print OUT "To: ".(defined($REPLYTO)?$REPLYTO:$USERADDR)."\n";
	      print OUT "To: ".$USERADDR."\n";
	      print OUT "Subject: $subj [".$page."/".$pages."]\n";
	      print OUT "X-FTN-Tearline: FTN robot at OberStation built on Perl version $]\n";
	      print OUT "X-FTN-Origin: OberStation FAQServer                           (2:463/768\@FidoNet)\n";
	      print OUT "\n";
	    }
	    print OUT $_;
	    $i++;
	    if (!($i % $SizeSplitMessage) && ($page != $pages)) { #   
	      print OUT "\n...     ...";
	      close(OUT);
	    }
          }			#  
	    if (($i % $SizeSplitMessage) || ($page == $pages)) { #  
	          print OUT "\n...   .";
	          close(OUT);
	    }
      }
    close(REQFILE);
  }
}
